package com.we;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.nio.charset.Charset;
import java.util.Iterator;


public class HttpServer { 
	public static void main(String[] args) throws IOException {
		
		 //  ServerSocketChanne18080˿
		 ServerSocketChannel ssc = ServerSocketChannel.open(); 
		 ssc.socket().bind(new InetSocketAddress(8080));
		 // Ϊģʽ
		 ssc.configureBlocking(false);
		 // Ϊsscעѡ
		 Selector selector = Selector.open();
		 ssc.register(selector, SelectionKey.OP_ACCEPT);
		 // 
		 while (true) {
			// ȴÿεȴ3s3s̼߳У0ֱ߲
			if (selector.select(3000) == 0) {
				continue;
			}
		    // ȡ SelectionKey
			Iterator<SelectionKey> keyIter = selector.selectedKeys().iterator();
			
			while (keyIter.hasNext()) {
				SelectionKey key  = keyIter.next();
				// ̴߳SelectionKey
				new Thread(new HttpHandler(key)).run();
				//  ӴSelectionKeyƳǰʹõkey
				keyIter.remove();
			}
		 } 
	}
	
	private static class HttpHandler implements Runnable {
		private int bufferSize = 1024;
		private String localCharest = "UTF-8";
		private SelectionKey key;
		
		public HttpHandler(SelectionKey key) {
			this.key = key;
		}
		
		public void handleAccept() throws IOException {
			SocketChannel clientChannel = ((ServerSocketChannel)key.channel()).accept();
			clientChannel.configureBlocking(false);
			clientChannel.register(key.selector(), SelectionKey.OP_READ, ByteBuffer.allocate(bufferSize));
		}
		
		public void handleRead() throws IOException {
			// ȡchannel
			SocketChannel sc = (SocketChannel)key.channel();
			// ȡbuffer
			ByteBuffer buffer = (ByteBuffer)key.attachment();
			buffer.clear();
			// ûжر
			if (sc.read(buffer) == -1) {
				sc.close();
			} else {
				// 
				buffer.flip();
				String  receivedString = Charset.forName(localCharest).newDecoder().decode(buffer).toString();
			    // ̨ӡͷ
				String[] requestMessage = receivedString.split("\r\n");
				for (String s : requestMessage) {
					System.out.println(s);
					// ˵ͷѾ
					if (s.isEmpty()) {
						break;
					}	
				}
				
				// ̨ӡϢ
				String[] firstLine = requestMessage[0].split(" ");
				System.out.println();
				System.out.println("Method:\t" + firstLine[0]);
				System.out.println("url:\t" + firstLine[1]);
				System.out.println("HTTP Version:\t" + firstLine[2]);
				System.out.println();
				
				// ؿͻ
				StringBuilder sendString = new StringBuilder();
				sendString.append("HTTP/1.1 200 OK\r\n");// ӦУ200ʾɹ
				sendString.append("Content-Type:text/html;charset=" + localCharest + "\r\n");
				sendString.append("\r\n");// ͷһ
				
				sendString.append("<html><head><title>ʾ</title></head></body>");
				sendString.append("յǣ<br/>" );
				
				for (String s : requestMessage) {
					sendString.append(s + "<br/>");
				}
				sendString.append("</body></html>");
				buffer = ByteBuffer.wrap(sendString.toString().getBytes(localCharest));
				sc.write(buffer);
				sc.close();
			}
			

			
			
		}

		@Override
		public void run() {
			try {
				// յʱ
				if (key.isAcceptable()) {
					handleAccept();
				}
				// 
				if (key.isReadable()) {
					handleRead();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			
		}
	}

}
